diff -ruN vdr-1.6.0/CONTRIBUTORS vdr-1.7.0/CONTRIBUTORS
--- vdr-1.6.0/CONTRIBUTORS	2008-03-18 18:34:00.000000000 +0100
+++ vdr-1.7.0/CONTRIBUTORS	2008-04-13 15:30:55.000000000 +0200
@@ -595,6 +595,8 @@
  not two hex digits after the '#'
  for suggesting to suppress the automatic shutdown if the remote control is
  currently disabled
+ for suggesting to improve logging system time changes to avoid problems on slow
+ systems under heavy load
 
 Jeremy Hall <jhall@UU.NET>
  for fixing an incomplete initialization of the filter parameters in eit.c
@@ -958,6 +960,7 @@
  for making the SVDRP command LSTC list the channels with group separators if the
  option ':groups' is given
  for fixing handling 3 and 4 byte UTF-8 symbols in Utf8CharGet()
+ for fixing initializing the timer's flags in the cTimer copy constructor
 
 Olivier Jacques <jacquesolivier@hotmail.com>)
  for translating OSD texts to the French language
@@ -1050,6 +1053,7 @@
  language
  for fixing displaying the free disk space when entering the recordings menu where
  the last replayed recording was in a subdirectory, and pressing Back
+ for setting the thread name, so that it can be seen in 'top -H'
 
 Ralf Klueber <ralf.klueber@vodafone.com>
  for reporting a bug in cutting a recording if there is only a single editing mark
@@ -1174,6 +1178,8 @@
  for reporting an invalid access in the section handler when ending VDR
  for pointing out that cDevice::Transferring() doesn't return the right value in the
  early stage of channel switching
+ for fixing displaying transponder data when it is modified
+ for fixing handling the counter in detection of pre 1.3.19 PS data
 
 Richard Robson <richard_robson@beeb.net>
  for reporting freezing replay if a timer starts while in Transfer Mode from the
@@ -1506,6 +1512,7 @@
  for translating OSD texts to the Estonian language
  for fixing a missing ',' in the Greek OSD texts
  for fixing a missing ',' in the Swedish OSD texts
+ for reporting problems with CAMs when checking the CAM status too frequently
 
 Milos Kapoun <m.kapoun@cra.cz>
  for suggesting to skip code table info in SI data
@@ -1702,6 +1709,7 @@
  Channel+ or Channel- is pressed
  for pointing out a possible problem with asprintf() if the return value is not
  checked
+ for fixing setting the OSD level in the 'osddemo' example
 
 Chad Flynt <hoochster@sofnet.com>
  for suggestions and experiments regarding the buffer reserve in cTransfer
diff -ruN vdr-1.6.0/HISTORY vdr-1.7.0/HISTORY
--- vdr-1.6.0/HISTORY	2008-03-23 11:26:08.000000000 +0100
+++ vdr-1.7.0/HISTORY	2008-04-13 15:35:09.000000000 +0200
@@ -5729,3 +5729,35 @@
 - Added Chinese language texts (thanks to Nan Feng).
 - Updated the Portuguese language texts.
 - Added a note about VDR_CHARSET_OVERRIDE to the INSTALL file.
+
+2008-04-13: Version 1.7.0
+
+- Re-implemented handling of DVB-S2, which first appeared in version 1.5.14, but was
+  revoked in version 1.5.15 in favor of making a stable version 1.6.0. VDR now
+  requires the "multiproto" DVB driver, e.g. from http://jusst.de/hg/multiproto.
+  Note that the channels.conf file now supports additional parameters, so you may
+  want to make sure you have a backup of this file in case you need to go back to
+  the previous version of VDR!
+- Fixed displaying transponder data when it is modified (thanks to Reinhard Nissl).
+- Fixed handling the counter in detection of pre 1.3.19 PS data (thanks to Reinhard
+  Nissl).
+- Improved logging system time changes to avoid problems on slow systems under
+  heavy load (suggested by Helmut Auer).
+- Now setting the thread name, so that it can be seen in 'top -H' (thanks to Rolf
+  Ahrenberg).
+- Fixed initializing the timer's flags in the cTimer copy constructor (thanks to
+  Andreas Mair).
+- Fixed setting the OSD level in the 'osddemo' example (thanks to Wolfgang Rohdewald).
+- Increased the time between checking the CAM status to 500ms to avoid problems
+  with some CAMs (reported by Arthur Konovalov).
+
+2008-04-13: Version 1.6.0-1
+
+- Fixed handling the counter in detection of pre 1.3.19 PS data (thanks to Reinhard
+  Nissl).
+- Improved logging system time changes to avoid problems on slow systems under
+  heavy load (suggested by Helmut Auer).
+- Fixed initializing the timer's flags in the cTimer copy constructor (thanks to
+  Andreas Mair).
+- Increased the time between checking the CAM status to 500ms to avoid problems
+  with some CAMs (reported by Arthur Konovalov).
diff -ruN vdr-1.6.0/PLUGINS/src/osddemo/HISTORY vdr-1.7.0/PLUGINS/src/osddemo/HISTORY
--- vdr-1.6.0/PLUGINS/src/osddemo/HISTORY	2007-08-15 15:17:40.000000000 +0200
+++ vdr-1.7.0/PLUGINS/src/osddemo/HISTORY	2008-04-13 15:02:53.000000000 +0200
@@ -17,3 +17,7 @@
 
 - Moved the "all" target in the Makefile before the "Implicit rules",
   so that a plain "make" will compile everything.
+
+2008-04-13: Version 0.1.3
+
+- Fixed setting the OSD level (thanks to Wolfgang Rohdewald).
diff -ruN vdr-1.6.0/PLUGINS/src/osddemo/osddemo.c vdr-1.7.0/PLUGINS/src/osddemo/osddemo.c
--- vdr-1.6.0/PLUGINS/src/osddemo/osddemo.c	2007-08-15 15:17:55.000000000 +0200
+++ vdr-1.7.0/PLUGINS/src/osddemo/osddemo.c	2008-04-13 14:59:57.000000000 +0200
@@ -3,12 +3,12 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: osddemo.c 1.4 2007/08/15 13:17:55 kls Exp $
+ * $Id: osddemo.c 2.1 2008/04/13 12:59:57 kls Exp $
  */
 
 #include <vdr/plugin.h>
 
-static const char *VERSION        = "0.1.2";
+static const char *VERSION        = "0.1.3";
 static const char *DESCRIPTION    = "Demo of arbitrary OSD setup";
 static const char *MAINMENUENTRY  = "Osd Demo";
 
@@ -41,7 +41,7 @@
 
 void cLineGame::Show(void)
 {
-  osd = cOsdProvider::NewOsd(100, 50);
+  osd = cOsdProvider::NewOsd(100, 50, 50);
   if (osd) {
      tArea Area = { 0, 0, 99, 199,  4 };
      osd->SetAreas(&Area, 1);
diff -ruN vdr-1.6.0/channels.c vdr-1.7.0/channels.c
--- vdr-1.6.0/channels.c	2008-03-05 17:42:50.000000000 +0100
+++ vdr-1.7.0/channels.c	2008-04-12 15:49:12.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.c 1.60 2008/03/05 16:42:50 kls Exp $
+ * $Id: channels.c 2.2 2008/04/12 13:49:12 kls Exp $
  */
 
 #include "channels.h"
@@ -21,67 +21,114 @@
 // --- Channel Parameter Maps ------------------------------------------------
 
 const tChannelParameterMap InversionValues[] = {
-  {   0, INVERSION_OFF },
-  {   1, INVERSION_ON },
-  { 999, INVERSION_AUTO },
+  {   0, DVBFE_INVERSION_OFF, trNOOP("off") },
+  {   1, DVBFE_INVERSION_ON,  trNOOP("on") },
+  { 999, DVBFE_INVERSION_AUTO },
   { -1 }
   };
 
 const tChannelParameterMap BandwidthValues[] = {
-  {   6, BANDWIDTH_6_MHZ },
-  {   7, BANDWIDTH_7_MHZ },
-  {   8, BANDWIDTH_8_MHZ },
-  { 999, BANDWIDTH_AUTO },
+  {   5, DVBFE_BANDWIDTH_5_MHZ, "5 MHz" },
+  {   6, DVBFE_BANDWIDTH_6_MHZ, "6 MHz" },
+  {   7, DVBFE_BANDWIDTH_7_MHZ, "7 MHz" },
+  {   8, DVBFE_BANDWIDTH_8_MHZ, "8 MHz" },
+  { 999, DVBFE_BANDWIDTH_AUTO },
   { -1 }
   };
 
 const tChannelParameterMap CoderateValues[] = {
-  {   0, FEC_NONE },
-  {  12, FEC_1_2 },
-  {  23, FEC_2_3 },
-  {  34, FEC_3_4 },
-  {  45, FEC_4_5 },
-  {  56, FEC_5_6 },
-  {  67, FEC_6_7 },
-  {  78, FEC_7_8 },
-  {  89, FEC_8_9 },
-  { 999, FEC_AUTO },
+  {   0, DVBFE_FEC_NONE, trNOOP("none") },
+  {  12, DVBFE_FEC_1_2,  "1/2" },
+  {  13, DVBFE_FEC_1_3,  "1/3" },
+  {  14, DVBFE_FEC_1_4,  "1/4" },
+  {  23, DVBFE_FEC_2_3,  "2/3" },
+  {  25, DVBFE_FEC_2_5,  "2/5" },
+  {  34, DVBFE_FEC_3_4,  "3/4" },
+  {  35, DVBFE_FEC_3_5,  "3/5" },
+  {  45, DVBFE_FEC_4_5,  "4/5" },
+  {  56, DVBFE_FEC_5_6,  "5/6" },
+  {  67, DVBFE_FEC_6_7,  "6/7" },
+  {  78, DVBFE_FEC_7_8,  "7/8" },
+  {  89, DVBFE_FEC_8_9,  "8/9" },
+  { 910, DVBFE_FEC_9_10, "9/10" },
+  { 999, DVBFE_FEC_AUTO },
   { -1 }
   };
 
 const tChannelParameterMap ModulationValues[] = {
-  {   0, QPSK },
-  {  16, QAM_16 },
-  {  32, QAM_32 },
-  {  64, QAM_64 },
-  { 128, QAM_128 },
-  { 256, QAM_256 },
-  { 999, QAM_AUTO },
+  {   0, DVBFE_MOD_NONE,    trNOOP("none") },
+  {   4, DVBFE_MOD_QAM4,    "QAM4" },
+  {  16, DVBFE_MOD_QAM16,   "QAM16" },
+  {  32, DVBFE_MOD_QAM32,   "QAM32" },
+  {  64, DVBFE_MOD_QAM64,   "QAM64" },
+  { 128, DVBFE_MOD_QAM128,  "QAM128" },
+  { 256, DVBFE_MOD_QAM256,  "QAM256" },
+  { 512, DVBFE_MOD_QAM512,  "QAM512" },
+  {1024, DVBFE_MOD_QAM1024, "QAM1024" },
+  {   1, DVBFE_MOD_BPSK,    "BPSK" },
+  {   2, DVBFE_MOD_QPSK,    "QPSK" },
+  {   3, DVBFE_MOD_OQPSK,   "OQPSK" },
+  {   5, DVBFE_MOD_8PSK,    "8PSK" },
+  {   6, DVBFE_MOD_16APSK,  "16APSK" },
+  {   7, DVBFE_MOD_32APSK,  "32APSK" },
+  {   8, DVBFE_MOD_OFDM,    "OFDM" },
+  {   9, DVBFE_MOD_COFDM,   "COFDM" },
+  {  10, DVBFE_MOD_VSB8,    "VSB8" },
+  {  11, DVBFE_MOD_VSB16,   "VSB16" },
+  { 998, DVBFE_MOD_QAMAUTO, "QAMAUTO" },
+  { 999, DVBFE_MOD_AUTO },
+  { -1 }
+  };
+
+const tChannelParameterMap SystemValues[] = {
+  {   0, DVBFE_DELSYS_DVBS,  "DVB-S" },
+  {   1, DVBFE_DELSYS_DVBS2, "DVB-S2" },
   { -1 }
   };
 
 const tChannelParameterMap TransmissionValues[] = {
-  {   2, TRANSMISSION_MODE_2K },
-  {   8, TRANSMISSION_MODE_8K },
-  { 999, TRANSMISSION_MODE_AUTO },
+  {   2, DVBFE_TRANSMISSION_MODE_2K, "2K" },
+  {   4, DVBFE_TRANSMISSION_MODE_4K, "4K" },
+  {   8, DVBFE_TRANSMISSION_MODE_8K, "8K" },
+  { 999, DVBFE_TRANSMISSION_MODE_AUTO },
   { -1 }
   };
 
 const tChannelParameterMap GuardValues[] = {
-  {   4, GUARD_INTERVAL_1_4 },
-  {   8, GUARD_INTERVAL_1_8 },
-  {  16, GUARD_INTERVAL_1_16 },
-  {  32, GUARD_INTERVAL_1_32 },
-  { 999, GUARD_INTERVAL_AUTO },
+  {   4, DVBFE_GUARD_INTERVAL_1_4,  "1/4" },
+  {   8, DVBFE_GUARD_INTERVAL_1_8,  "1/8" },
+  {  16, DVBFE_GUARD_INTERVAL_1_16, "1/16" },
+  {  32, DVBFE_GUARD_INTERVAL_1_32, "1/32" },
+  { 999, DVBFE_GUARD_INTERVAL_AUTO },
   { -1 }
   };
 
 const tChannelParameterMap HierarchyValues[] = {
-  {   0, HIERARCHY_NONE },
-  {   1, HIERARCHY_1 },
-  {   2, HIERARCHY_2 },
-  {   4, HIERARCHY_4 },
-  { 999, HIERARCHY_AUTO },
+  {   0, DVBFE_HIERARCHY_OFF, trNOOP("off") },
+  {   1, DVBFE_HIERARCHY_ON,  trNOOP("on") },
+  { 999, DVBFE_HIERARCHY_AUTO },
+  { -1 }
+  };
+
+const tChannelParameterMap AlphaValues[] = {
+  {   0, 0 },
+  {   1, DVBFE_ALPHA_1 },
+  {   2, DVBFE_ALPHA_2 },
+  {   4, DVBFE_ALPHA_4 },
+  { -1 }
+  };
+
+const tChannelParameterMap PriorityValues[] = {
+  {   0, DVBFE_STREAM_PRIORITY_HP, trNOOP("high") },
+  {   1, DVBFE_STREAM_PRIORITY_LP, trNOOP("low") },
+  { -1 }
+  };
+
+const tChannelParameterMap RollOffValues[] = {
+  {   0, DVBFE_ROLLOFF_UNKNOWN },
+  {  20, DVBFE_ROLLOFF_20, "0.20" },
+  {  25, DVBFE_ROLLOFF_25, "0.25" },
+  {  35, DVBFE_ROLLOFF_35, "0.35" },
   { -1 }
   };
 
@@ -107,11 +154,14 @@
   return -1;
 }
 
-int MapToUser(int Value, const tChannelParameterMap *Map)
+int MapToUser(int Value, const tChannelParameterMap *Map, const char **String)
 {
   int n = DriverIndex(Value, Map);
-  if (n >= 0)
+  if (n >= 0) {
+     if (String)
+        *String = tr(Map[n].userString);
      return Map[n].userValue;
+     }
   return -1;
 }
 
@@ -167,14 +217,18 @@
   provider = strdup("");
   portalName = strdup("");
   memset(&__BeginData__, 0, (char *)&__EndData__ - (char *)&__BeginData__);
-  inversion    = INVERSION_AUTO;
-  bandwidth    = BANDWIDTH_AUTO;
-  coderateH    = FEC_AUTO;
-  coderateL    = FEC_AUTO;
-  modulation   = QAM_AUTO;
-  transmission = TRANSMISSION_MODE_AUTO;
-  guard        = GUARD_INTERVAL_AUTO;
-  hierarchy    = HIERARCHY_AUTO;
+  inversion    = DVBFE_INVERSION_AUTO;
+  bandwidth    = DVBFE_BANDWIDTH_AUTO;
+  coderateH    = DVBFE_FEC_AUTO;
+  coderateL    = DVBFE_FEC_AUTO;
+  modulation   = DVBFE_MOD_AUTO;
+  system       = DVBFE_DELSYS_DVBS;
+  transmission = DVBFE_TRANSMISSION_MODE_AUTO;
+  guard        = DVBFE_GUARD_INTERVAL_AUTO;
+  hierarchy    = DVBFE_HIERARCHY_AUTO;
+  alpha        = 0;
+  priority     = DVBFE_STREAM_PRIORITY_HP;
+  rollOff      = DVBFE_ROLLOFF_UNKNOWN;
   modification = CHANNELMOD_NONE;
   schedule     = NULL;
   linkChannels = NULL;
@@ -277,13 +331,17 @@
      coderateH    = Channel->coderateH;
      coderateL    = Channel->coderateL;
      modulation   = Channel->modulation;
+     system       = Channel->system;
      transmission = Channel->transmission;
      guard        = Channel->guard;
      hierarchy    = Channel->hierarchy;
+     alpha        = Channel->alpha;
+     priority     = Channel->priority;
+     rollOff      = Channel->rollOff;
      }
 }
 
-bool cChannel::SetSatTransponderData(int Source, int Frequency, char Polarization, int Srate, int CoderateH)
+bool cChannel::SetSatTransponderData(int Source, int Frequency, char Polarization, int Srate, int CoderateH, int Modulation, int System, int RollOff)
 {
   // Workarounds for broadcaster stupidity:
   // Some providers broadcast the transponder frequency of their channels with two different
@@ -297,19 +355,22 @@
   if (abs(srate - Srate) <= 1)
      Srate = srate;
 
-  if (source != Source || frequency != Frequency || polarization != Polarization || srate != Srate || coderateH != CoderateH) {
-     if (Number()) {
-        dsyslog("changing transponder data of channel %d from %s:%d:%c:%d:%d to %s:%d:%c:%d:%d", Number(), *cSource::ToString(source), frequency, polarization, srate, coderateH, *cSource::ToString(Source), Frequency, Polarization, Srate, CoderateH);
-        modification |= CHANNELMOD_TRANSP;
-        Channels.SetModified();
-        }
+  if (source != Source || frequency != Frequency || polarization != Polarization || srate != Srate || coderateH != CoderateH || modulation != Modulation || system != System || rollOff != RollOff) {
+     cString OldTransponderData = TransponderDataToString();
      source = Source;
      frequency = Frequency;
      polarization = Polarization;
      srate = Srate;
      coderateH = CoderateH;
-     modulation = QPSK;
+     modulation = Modulation;
+     system = System;
+     rollOff = RollOff;
      schedule = NULL;
+     if (Number()) {
+        dsyslog("changing transponder data of channel %d from %s to %s", Number(), *OldTransponderData, *TransponderDataToString());
+        modification |= CHANNELMOD_TRANSP;
+        Channels.SetModified();
+        }
      }
   return true;
 }
@@ -317,29 +378,26 @@
 bool cChannel::SetCableTransponderData(int Source, int Frequency, int Modulation, int Srate, int CoderateH)
 {
   if (source != Source || frequency != Frequency || modulation != Modulation || srate != Srate || coderateH != CoderateH) {
-     if (Number()) {
-        dsyslog("changing transponder data of channel %d from %s:%d:%d:%d:%d to %s:%d:%d:%d:%d", Number(), *cSource::ToString(source), frequency, modulation, srate, coderateH, *cSource::ToString(Source), Frequency, Modulation, Srate, CoderateH);
-        modification |= CHANNELMOD_TRANSP;
-        Channels.SetModified();
-        }
+     cString OldTransponderData = TransponderDataToString();
      source = Source;
      frequency = Frequency;
      modulation = Modulation;
      srate = Srate;
      coderateH = CoderateH;
      schedule = NULL;
+     if (Number()) {
+        dsyslog("changing transponder data of channel %d from %s to %s", Number(), *OldTransponderData, *TransponderDataToString());
+        modification |= CHANNELMOD_TRANSP;
+        Channels.SetModified();
+        }
      }
   return true;
 }
 
-bool cChannel::SetTerrTransponderData(int Source, int Frequency, int Bandwidth, int Modulation, int Hierarchy, int CoderateH, int CoderateL, int Guard, int Transmission)
+bool cChannel::SetTerrTransponderData(int Source, int Frequency, int Bandwidth, int Modulation, int Hierarchy, int CoderateH, int CoderateL, int Guard, int Transmission, int Alpha, int Priority)
 {
-  if (source != Source || frequency != Frequency || bandwidth != Bandwidth || modulation != Modulation || hierarchy != Hierarchy || coderateH != CoderateH || coderateL != CoderateL || guard != Guard || transmission != Transmission) {
-     if (Number()) {
-        dsyslog("changing transponder data of channel %d from %s:%d:%d:%d:%d:%d:%d:%d:%d to %s:%d:%d:%d:%d:%d:%d:%d:%d", Number(), *cSource::ToString(source), frequency, bandwidth, modulation, hierarchy, coderateH, coderateL, guard, transmission, *cSource::ToString(Source), Frequency, Bandwidth, Modulation, Hierarchy, CoderateH, CoderateL, Guard, Transmission);
-        modification |= CHANNELMOD_TRANSP;
-        Channels.SetModified();
-        }
+  if (source != Source || frequency != Frequency || bandwidth != Bandwidth || modulation != Modulation || hierarchy != Hierarchy || coderateH != CoderateH || coderateL != CoderateL || guard != Guard || transmission != Transmission || alpha != Alpha || priority != Priority) {
+     cString OldTransponderData = TransponderDataToString();
      source = Source;
      frequency = Frequency;
      bandwidth = Bandwidth;
@@ -349,7 +407,14 @@
      coderateL = CoderateL;
      guard = Guard;
      transmission = Transmission;
+     alpha = Alpha;
+     priority = Priority;
      schedule = NULL;
+     if (Number()) {
+        dsyslog("changing transponder data of channel %d from %s to %s", Number(), *OldTransponderData, *TransponderDataToString());
+        modification |= CHANNELMOD_TRANSP;
+        Channels.SetModified();
+        }
      }
   return true;
 }
@@ -587,6 +652,13 @@
   return Value >= 0 && Value != 999 ? sprintf(p, "%c%d", Name, Value) : 0;
 }
 
+cString cChannel::TransponderDataToString(void) const
+{
+  if (cSource::IsTerr(source))
+     return cString::sprintf("%d:%s:%s", frequency, *ParametersToString(), *cSource::ToString(source));
+  return cString::sprintf("%d:%s:%s:%d", frequency, *ParametersToString(), *cSource::ToString(source), srate);
+}
+
 cString cChannel::ParametersToString(void) const
 {
   char type = **cSource::ToString(source);
@@ -597,13 +669,17 @@
   char *q = buffer;
   *q = 0;
   ST(" S ")  q += sprintf(q, "%c", polarization);
-  ST("CST")  q += PrintParameter(q, 'I', MapToUser(inversion, InversionValues));
+  ST("  T")  q += PrintParameter(q, 'A', MapToUser(alpha, AlphaValues));
+  ST("  T")  q += PrintParameter(q, 'B', MapToUser(bandwidth, BandwidthValues));
   ST("CST")  q += PrintParameter(q, 'C', MapToUser(coderateH, CoderateValues));
   ST("  T")  q += PrintParameter(q, 'D', MapToUser(coderateL, CoderateValues));
-  ST("C T")  q += PrintParameter(q, 'M', MapToUser(modulation, ModulationValues));
-  ST("  T")  q += PrintParameter(q, 'B', MapToUser(bandwidth, BandwidthValues));
-  ST("  T")  q += PrintParameter(q, 'T', MapToUser(transmission, TransmissionValues));
   ST("  T")  q += PrintParameter(q, 'G', MapToUser(guard, GuardValues));
+  ST("CST")  q += PrintParameter(q, 'I', MapToUser(inversion, InversionValues));
+  ST("CST")  q += PrintParameter(q, 'M', MapToUser(modulation, ModulationValues));
+  ST(" S ")  q += PrintParameter(q, 'O', MapToUser(rollOff, RollOffValues));
+  ST("  T")  q += PrintParameter(q, 'P', MapToUser(priority, PriorityValues));
+  ST(" S ")  q += PrintParameter(q, 'S', MapToUser(system, SystemValues));
+  ST("  T")  q += PrintParameter(q, 'T', MapToUser(transmission, TransmissionValues));
   ST("  T")  q += PrintParameter(q, 'Y', MapToUser(hierarchy, HierarchyValues));
   return buffer;
 }
@@ -628,6 +704,7 @@
 {
   while (s && *s) {
         switch (toupper(*s)) {
+          case 'A': s = ParseParameter(s, alpha, AlphaValues); break;
           case 'B': s = ParseParameter(s, bandwidth, BandwidthValues); break;
           case 'C': s = ParseParameter(s, coderateH, CoderateValues); break;
           case 'D': s = ParseParameter(s, coderateL, CoderateValues); break;
@@ -636,7 +713,11 @@
           case 'I': s = ParseParameter(s, inversion, InversionValues); break;
           case 'L': polarization = *s++; break;
           case 'M': s = ParseParameter(s, modulation, ModulationValues); break;
+          case 'Z':// for compatibility with the original DVB-S2 patch - may be removed in future versions
+          case 'O': s = ParseParameter(s, rollOff, RollOffValues); break;
+          case 'P': s = ParseParameter(s, priority, PriorityValues); break;
           case 'R': polarization = *s++; break;
+          case 'S': s = ParseParameter(s, system, SystemValues); break;
           case 'T': s = ParseParameter(s, transmission, TransmissionValues); break;
           case 'V': polarization = *s++; break;
           case 'Y': s = ParseParameter(s, hierarchy, HierarchyValues); break;
diff -ruN vdr-1.6.0/channels.h vdr-1.7.0/channels.h
--- vdr-1.6.0/channels.h	2008-02-08 14:48:31.000000000 +0100
+++ vdr-1.7.0/channels.h	2008-04-12 15:46:50.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: channels.h 1.47 2008/02/08 13:48:31 kls Exp $
+ * $Id: channels.h 2.2 2008/04/12 13:46:50 kls Exp $
  */
 
 #ifndef __CHANNELS_H
@@ -50,10 +50,10 @@
 struct tChannelParameterMap {
   int userValue;
   int driverValue;
+  const char *userString;
   };
 
-//XXX into cChannel???
-int MapToUser(int Value, const tChannelParameterMap *Map);
+int MapToUser(int Value, const tChannelParameterMap *Map, const char **String = NULL);
 int MapToDriver(int Value, const tChannelParameterMap *Map);
 int UserIndex(int Value, const tChannelParameterMap *Map);
 int DriverIndex(int Value, const tChannelParameterMap *Map);
@@ -62,9 +62,13 @@
 extern const tChannelParameterMap BandwidthValues[];
 extern const tChannelParameterMap CoderateValues[];
 extern const tChannelParameterMap ModulationValues[];
+extern const tChannelParameterMap SystemValues[];
 extern const tChannelParameterMap TransmissionValues[];
 extern const tChannelParameterMap GuardValues[];
 extern const tChannelParameterMap HierarchyValues[];
+extern const tChannelParameterMap AlphaValues[];
+extern const tChannelParameterMap PriorityValues[];
+extern const tChannelParameterMap RollOffValues[];
 
 struct tChannelID {
 private:
@@ -140,14 +144,19 @@
   int coderateH;
   int coderateL;
   int modulation;
+  int system;
   int transmission;
   int guard;
   int hierarchy;
+  int alpha;
+  int priority;
+  int rollOff;
   int __EndData__;
   int modification;
   mutable const cSchedule *schedule;
   cLinkChannels *linkChannels;
   cChannel *refChannel;
+  cString TransponderDataToString(void) const;
   cString ParametersToString(void) const;
   bool StringToParameters(const char *s);
 public:
@@ -194,9 +203,13 @@
   int CoderateH(void) const { return coderateH; }
   int CoderateL(void) const { return coderateL; }
   int Modulation(void) const { return modulation; }
+  int System(void) const { return system; }
   int Transmission(void) const { return transmission; }
   int Guard(void) const { return guard; }
   int Hierarchy(void) const { return hierarchy; }
+  int Alpha(void) const { return alpha; }
+  int Priority(void) const { return priority; }
+  int RollOff(void) const { return rollOff; }
   const cLinkChannels* LinkChannels(void) const { return linkChannels; }
   const cChannel *RefChannel(void) const { return refChannel; }
   bool IsCable(void) const { return cSource::IsCable(source); }
@@ -206,9 +219,9 @@
   bool HasTimer(void) const;
   int Modification(int Mask = CHANNELMOD_ALL);
   void CopyTransponderData(const cChannel *Channel);
-  bool SetSatTransponderData(int Source, int Frequency, char Polarization, int Srate, int CoderateH);
+  bool SetSatTransponderData(int Source, int Frequency, char Polarization, int Srate, int CoderateH, int Modulation, int System, int RollOff);
   bool SetCableTransponderData(int Source, int Frequency, int Modulation, int Srate, int CoderateH);
-  bool SetTerrTransponderData(int Source, int Frequency, int Bandwidth, int Modulation, int Hierarchy, int CodeRateH, int CodeRateL, int Guard, int Transmission);
+  bool SetTerrTransponderData(int Source, int Frequency, int Bandwidth, int Modulation, int Hierarchy, int CodeRateH, int CodeRateL, int Guard, int Transmission, int Alpha, int Priority);
   void SetId(int Nid, int Tid, int Sid, int Rid = 0);
   void SetName(const char *Name, const char *ShortName, const char *Provider);
   void SetPortalName(const char *PortalName);
diff -ruN vdr-1.6.0/ci.c vdr-1.7.0/ci.c
--- vdr-1.6.0/ci.c	2007-04-30 15:02:49.000000000 +0200
+++ vdr-1.7.0/ci.c	2008-04-13 15:28:52.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.c 1.48 2007/04/30 13:02:49 kls Exp $
+ * $Id: ci.c 2.1 2008/04/13 13:28:52 kls Exp $
  */
 
 #include "ci.h"
@@ -1525,7 +1525,7 @@
 
 cCamSlots CamSlots;
 
-#define MODULE_CHECK_INTERVAL 100 // ms
+#define MODULE_CHECK_INTERVAL 500 // ms
 #define MODULE_RESET_TIMEOUT    2 // s
 
 cCamSlot::cCamSlot(cCiAdapter *CiAdapter)
diff -ruN vdr-1.6.0/config.h vdr-1.7.0/config.h
--- vdr-1.6.0/config.h	2008-03-23 11:26:10.000000000 +0100
+++ vdr-1.7.0/config.h	2008-04-12 15:02:10.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 1.310 2008/03/23 10:26:10 kls Exp $
+ * $Id: config.h 2.1 2008/04/12 13:02:10 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.6.0"
-#define VDRVERSNUM   10600  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.0"
+#define VDRVERSNUM   10700  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.6.0"
-#define APIVERSNUM   10600  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.0"
+#define APIVERSNUM   10700  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
diff -ruN vdr-1.6.0/device.c vdr-1.7.0/device.c
--- vdr-1.6.0/device.c	2008-03-09 11:03:34.000000000 +0100
+++ vdr-1.7.0/device.c	2008-04-12 16:12:14.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 1.157 2008/03/09 10:03:34 kls Exp $
+ * $Id: device.c 2.2 2008/04/12 14:12:14 kls Exp $
  */
 
 #include "device.h"
@@ -355,6 +355,21 @@
   return (0 <= Index && Index < numDevices) ? device[Index] : NULL;
 }
 
+static int GetClippedNumProvidedSystems(int AvailableBits, cDevice *Device)
+{
+  int MaxNumProvidedSystems = 1 << AvailableBits;
+  int NumProvidedSystems = Device->NumProvidedSystems();
+  if (NumProvidedSystems > MaxNumProvidedSystems) {
+     esyslog("ERROR: device %d supports %d modulation systems but cDevice::GetDevice() currently only supports %d delivery systems which should be fixed", Device->CardIndex() + 1, NumProvidedSystems, MaxNumProvidedSystems);
+     NumProvidedSystems = MaxNumProvidedSystems;
+     }
+  else if (NumProvidedSystems <= 0) {
+     esyslog("ERROR: device %d reported an invalid number (%d) of supported delivery systems - assuming 1", Device->CardIndex() + 1, NumProvidedSystems);
+     NumProvidedSystems = 1;
+     }
+  return NumProvidedSystems;
+}
+
 cDevice *cDevice::GetDevice(const cChannel *Channel, int Priority, bool LiveView)
 {
   cDevice *AvoidDevice = avoidDevice;
@@ -408,6 +423,7 @@
              imp <<= 1; imp |= LiveView ? !device[i]->IsPrimaryDevice() || ndr : 0;                                  // prefer the primary device for live viewing if we don't need to detach existing receivers
              imp <<= 1; imp |= !device[i]->Receiving() && (device[i] != cTransferControl::ReceiverDevice() || device[i]->IsPrimaryDevice()) || ndr; // use receiving devices if we don't need to detach existing receivers, but avoid primary device in local transfer mode
              imp <<= 1; imp |= device[i]->Receiving();                                                               // avoid devices that are receiving
+             imp <<= 2; imp |= GetClippedNumProvidedSystems(2, device[i]) - 1;                                       // avoid cards which support multiple delivery systems
              imp <<= 1; imp |= device[i] == cTransferControl::ReceiverDevice();                                      // avoid the Transfer Mode receiver device
              imp <<= 8; imp |= min(max(device[i]->Priority() + MAXPRIORITY, 0), 0xFF);                               // use the device with the lowest priority (+MAXPRIORITY to assure that values -99..99 can be used)
              imp <<= 8; imp |= min(max((NumUsableSlots ? SlotPriority[j] : 0) + MAXPRIORITY, 0), 0xFF);              // use the CAM slot with the lowest priority (+MAXPRIORITY to assure that values -99..99 can be used)
@@ -712,6 +728,11 @@
   return false;
 }
 
+int cDevice::NumProvidedSystems(void) const
+{
+  return 0;
+}
+
 bool cDevice::IsTunedToTransponder(const cChannel *Channel)
 {
   return false;
@@ -1273,7 +1294,7 @@
                uchar SubStreamIndex = SubStreamId & 0x1F;
 
                // Compatibility mode for old VDR recordings, where 0xBD was only AC3:
-pre_1_3_19_PrivateStreamDeteced:
+pre_1_3_19_PrivateStreamDetected:
                if (pre_1_3_19_PrivateStream > MIN_PRE_1_3_19_PRIVATESTREAM) {
                   SubStreamId = c;
                   SubStreamType = 0x80;
@@ -1314,7 +1335,8 @@
                          if (pre_1_3_19_PrivateStream > MIN_PRE_1_3_19_PRIVATESTREAM) {
                             dsyslog("switching to pre 1.3.19 Dolby Digital compatibility mode - substream id = %02X", SubStreamId);
                             ClrAvailableTracks();
-                            goto pre_1_3_19_PrivateStreamDeteced;
+                            pre_1_3_19_PrivateStream = MIN_PRE_1_3_19_PRIVATESTREAM + 1;
+                            goto pre_1_3_19_PrivateStreamDetected;
                             }
                          }
                  }
diff -ruN vdr-1.6.0/device.h vdr-1.7.0/device.h
--- vdr-1.6.0/device.h	2008-02-23 14:13:04.000000000 +0100
+++ vdr-1.7.0/device.h	2008-04-12 13:11:23.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 1.91 2008/02/23 13:13:04 kls Exp $
+ * $Id: device.h 2.1 2008/04/12 11:11:23 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -228,6 +228,12 @@
          ///< function itself actually returns true.
          ///< The default implementation always returns false, so a derived cDevice
          ///< class that can provide channels must implement this function.
+  virtual int NumProvidedSystems(void) const;
+         ///< Returns the number of individual "delivery systems" this device provides.
+         ///< The default implementation returns 0, so any derived class that can
+         ///< actually provide channels must implement this function.
+         ///< The result of this function is used when selecting a device, in order
+         ///< to avoid devices that provide more than one system.
   virtual bool IsTunedToTransponder(const cChannel *Channel);
          ///< Returns true if this device is currently tuned to the given Channel's
          ///< transponder.
